<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic
  PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="preferences-editor-format-xml">
  <title>XML Preferences</title>
  <prolog>
    <metadata>
      <keywords>
        <indexterm>Preferences<indexterm>XML formatting</indexterm></indexterm>
      </keywords>
    </metadata>
  </prolog>
  <body>
    <p id="p_fdp_bgk_54b">To configure the <uicontrol>XML</uicontrol> Formatting options, <ph
        conkeyref="reusables-preferences-pages/open-the-preferences-page"/> and go to <menucascade>
        <uicontrol>Editor</uicontrol>
        <uicontrol>Format</uicontrol>
        <uicontrol>XML</uicontrol>
      </menucascade>.</p>
    <p id="p_gdp_bgk_54b">The following options are available:<dl id="dl_hdp_bgk_54b">
        <dlentry id="dlentry_idp_bgk_54b">
          <dt><uicontrol product="author developer editor">Format</uicontrol><uicontrol
              product="authorEclipse developerEclipse editorEclipse">Format and Indent</uicontrol>
            Section</dt>
          <dd>
            <p id="p_jdp_bgk_54b">This section includes the following drop-down boxes:</p>
            <p id="p_kdp_bgk_54b">
              <dl id="dl_ldp_bgk_54b">
                <dlentry id="dlentry_mdp_bgk_54b">
                  <dt><uicontrol>Preserve empty lines</uicontrol></dt>
                  <dd>The <uicontrol>Format and Indent</uicontrol> operation preserves all empty
                    lines found in the document.</dd>
                </dlentry>
                <dlentry id="dlentry_ndp_bgk_54b">
                  <dt><uicontrol>Preserve text as it is</uicontrol></dt>
                  <dd>The <uicontrol>Format and Indent</uicontrol> operation preserves text content
                    as it is, without removing or adding any white space.</dd>
                </dlentry>
                <dlentry id="dlentry_odp_bgk_54b">
                  <dt><uicontrol>Preserve line breaks in attributes</uicontrol></dt>
                  <dd>Line breaks found in attribute values are preserved.<note id="note_pdp_bgk_54b">When this option is
                      selected, the <xref
                        href="#preferences-editor-format-xml/break-long-attributes" format="dita"
                          ><uicontrol>Break long attributes</uicontrol> option</xref> is
                      automatically disabled.</note></dd>
                </dlentry>
                <dlentry id="break-long-attributes">
                  <dt><uicontrol>Break long attributes</uicontrol></dt>
                  <dd>The <uicontrol>Format and Indent</uicontrol> operation breaks long attribute
                    values.</dd>
                </dlentry>
                <dlentry id="dlentry_qdp_bgk_54b">
                  <dt><uicontrol>Indent inline elements</uicontrol></dt>
                  <dd>
                    <p id="p_rdp_bgk_54b">The <term keyref="glossentry_inline-element">inline elements</term> are
                      indented on separate lines if they are preceded by white spaces and they
                      follow another element start or end tag. For example:</p>
                    <p id="p_sdp_bgk_54b">Original XML:
                      <codeblock  xml:space="preserve" id="codeblock_tdp_bgk_54b">&lt;root&gt;
  text &lt;parent&gt; &lt;child&gt;&lt;/child&gt; &lt;/parent&gt;
&lt;/root&gt;</codeblock></p>
                    <p id="p_udp_bgk_54b"><uicontrol>Indent inline elements</uicontrol>
                      selected:<codeblock  xml:space="preserve" id="codeblock_vdp_bgk_54b">&lt;root&gt; text &lt;parent&gt;
    &lt;child/&gt;
  &lt;/parent&gt;
&lt;/root&gt;</codeblock></p>
                    <p id="p_wdp_bgk_54b"><uicontrol>Indent inline elements</uicontrol> not
                      selected:<codeblock  xml:space="preserve" id="codeblock_xdp_bgk_54b">&lt;root&gt; text &lt;parent&gt; &lt;child/&gt; &lt;/parent&gt; &lt;/root&gt;</codeblock></p>
                  </dd>
                </dlentry>
                <dlentry id="dlentry_ydp_bgk_54b">
                  <dt><uicontrol>Expand empty elements</uicontrol></dt>
                  <dd>If not selected (default), the <uicontrol>Format and Indent</uicontrol>
                    operation results in an empty XML element being serialized in a compact form
                      (<codeph>&lt;a atr1="v1"/&gt;</codeph>). If selected, the same operation
                    results in empty XML elements being serialized in expanded form (for example,
                      <codeph>&lt;a atr1="v1"&gt;&lt;/a&gt;</codeph>).<note type="other"
                      othertype="Notes" product="author editor authorEclipse editorEclipse" id="note_zdp_bgk_54b">
                      <ul id="ul_a2p_bgk_54b">
                        <li id="li_b2p_bgk_54b">When using the <uicontrol>Format and Indent</uicontrol> operation in
                            <uicontrol>Text</uicontrol> mode, if the <xref
                            href="#preferences-editor-format-xml/schema-aware-format-indent"
                            format="dita"><uicontrol>Schema-aware format and indent</uicontrol>
                            option</xref> is enabled, <ph keyref="product"/> will use information
                          from the associated schema and avoid expanding tags for elements that are
                          defined as <i>empty</i> in the schema.</li>
                        <li id="li_c2p_bgk_54b">When saving a document in <uicontrol>Author</uicontrol> mode, if the
                            <xref
                            href="preferences-schema-aware.dita#preferences-schema-aware/schema-aware-normalization"
                              ><uicontrol>Schema-aware normalization, format, and indent</uicontrol>
                            option in the <uicontrol>Schema-Aware</uicontrol> preferences
                            page</xref> is enabled, <ph keyref="product"/> will use information from
                          the associated schema and avoid expanding tags for elements that are
                          defined as <i>empty</i> in the schema (therefore, text or other elements
                          are not allowed inside them).</li>
                      </ul>
                    </note><note product="developer developerEclipse" id="note_d2p_bgk_54b">When using the
                        <uicontrol>Format and Indent</uicontrol> operation in
                        <uicontrol>Text</uicontrol> mode, if the <xref
                        href="#preferences-editor-format-xml/schema-aware-format-indent"
                        format="dita"><uicontrol>Schema-aware format and indent</uicontrol>
                        option</xref> is enabled, <ph keyref="product"/> will use information from
                      the associated schema and avoid expanding tags for elements that are defined
                      as <i>empty</i> in the schema.</note></dd>
                </dlentry>
                <dlentry id="dlentry_e2p_bgk_54b">
                  <dt><uicontrol>Sort attributes</uicontrol></dt>
                  <dd>The <uicontrol>Format and Indent</uicontrol> operation sorts the attributes of
                    an element lexicographically.</dd>
                </dlentry>
                <dlentry id="dlentry_f2p_bgk_54b">
                  <dt><uicontrol>Add space before slash in empty elements</uicontrol></dt>
                  <dd>Inserts a space character before the trailing / and &gt; of empty
                    elements.</dd>
                </dlentry>
                <dlentry id="dlentry_g2p_bgk_54b">
                  <dt><uicontrol>Break line before an attribute name</uicontrol></dt>
                  <dd>When selected, the <uicontrol>Format and Indent</uicontrol> operation always
                    breaks the line before any attribute name in an XML element. By default, the
                    setting is not selected, which means that new lines might still be added before
                    the attribute names but only if the line of content would overflow the maximum
                    line width specified in the <xref href="preferences-editor-format.dita"
                        ><uicontrol>Format</uicontrol> preferences page</xref>.</dd>
                </dlentry>
              </dl>
            </p>
          </dd>
        </dlentry>
        <dlentry id="element-spacing-section">
          <dt><uicontrol>Element Spacing</uicontrol> Section</dt>
          <dd>
            <p id="p_h2p_bgk_54b">This section controls how the application handles whitespaces found in XML content.
              You can <uicontrol>Add</uicontrol> or <uicontrol>Remove</uicontrol> element names or
              simplified XPath expressions in the various tabs.</p>
            <p id="simplified-XPath">The XPath expressions can accept multiple attribute conditions
              and inside each condition you can use <i>AND/OR</i> boolean operators and parentheses
              to override the priority.</p>
            <p id="p_i2p_bgk_54b">You can use one or more of the following attribute conditions (default attribute
              values are not taken into account):<ul id="ul_j2p_bgk_54b">
                <li id="li_k2p_bgk_54b"><i>element[@attr]</i> - Matches all instances of the specified element that
                  include the specified attribute.</li>
                <li id="li_l2p_bgk_54b"><i>element[not(@attr)]</i> - Matches all instances of the specified element that
                  do not include the specified attribute.</li>
                <li id="li_m2p_bgk_54b"><i>element[@attr = "value"]</i> - Matches all instances of the specified element
                  that include the specified attribute with the given value.</li>
                <li id="li_n2p_bgk_54b"><i>element[@attr != "value"]</i> - Matches all instances of the specified
                  element that include the specified attribute and its value is different than the
                  one given.</li>
              </ul></p>
            <p id="p_o2p_bgk_54b"><b>Example:</b> The following is an example of how you could use multiple boolean
              operators and parentheses inside an attribute
              condition:<codeblock  id="codeblock_p2p_bgk_54b">*[@a and @b or @c and @d]
*[@a and (@b or @c) and @d]</codeblock></p>
            <p id="p_q2p_bgk_54b">The following are just examples of how simplified XPath expressions might look like:<ul id="ul_r2p_bgk_54b">
                <li id="li_s2p_bgk_54b"><codeph>elementName</codeph></li>
                <li id="li_t2p_bgk_54b"><codeph>//elementName</codeph></li>
                <li id="li_u2p_bgk_54b"><codeph>/elementName1/elementName2/elementName3</codeph></li>
                <li id="li_v2p_bgk_54b"><codeph>//xs:localName</codeph> Note: The namespace prefixes (such as
                    <codeph>xs</codeph>) are treated as part of the element name without taking its
                  binding to a namespace into account.</li>
                <li id="li_w2p_bgk_54b"><codeph>//xs:documentation[@lang="en"]</codeph></li>
              </ul></p>
            <p id="p_x2p_bgk_54b">The tabs are as follows:<dl id="dl_y2p_bgk_54b">
                <dlentry id="dlentry_z2p_bgk_54b">
                  <dt><uicontrol>Preserve space</uicontrol></dt>
                  <dd>List of elements that will have the <uicontrol>Format and Indent</uicontrol>
                    operation preserve the whitespaces (such as blanks, tabs, and newlines).</dd>
                </dlentry>
                <dlentry id="dlentry_afp_bgk_54b">
                  <dt><uicontrol>Default space</uicontrol></dt>
                  <dd>List of elements that will have the content normalized (multiple contiguous
                    whitespaces are replaced by a single space), before applying the
                      <uicontrol>Format and Indent</uicontrol> operation.</dd>
                </dlentry>
                <dlentry id="dlentry_bfp_bgk_54b">
                  <dt><uicontrol>Mixed content</uicontrol></dt>
                  <dd>The elements from this list are treated as mixed content when applying the
                      <uicontrol>Format and Indent</uicontrol> operation. The lines are split only
                    when whitespaces are encountered.</dd>
                </dlentry>
                <dlentry id="dlentry_cfp_bgk_54b">
                  <dt><uicontrol>Line break</uicontrol></dt>
                  <dd>List of elements that will have line breaks inserted, regardless of their
                    content. You can choose to break the line <i>before</i> the element,
                      <i>after</i>, or both.</dd>
                </dlentry>
              </dl></p>
          </dd>
        </dlentry>
        <dlentry id="schema-aware-format-indent">
          <dt><uicontrol id="pref_sa_format">Schema-aware format and indent</uicontrol></dt>
          <dd>The <uicontrol>Format and Indent</uicontrol> operation takes the schema information
            into account with regard to the <i>space preserve</i>, <i>mixed</i>, or <i>element
              only</i> properties of an element.</dd>
        </dlentry>
        <dlentry id="dlentry_dfp_bgk_54b">
          <dt><uicontrol>Indent</uicontrol> Section</dt>
          <dd>
            <p id="p_efp_bgk_54b">Includes the following options:</p>
            <p id="p_ffp_bgk_54b">
              <dl id="dl_gfp_bgk_54b">
                <dlentry id="dlentry_hfp_bgk_54b">
                  <dt><uicontrol>Indent (when typing) in preserve space elements</uicontrol></dt>
                  <dd>Normally, the <term>Preserve space</term> elements (identified by the
                      <codeph>xml:space</codeph> attribute set to <codeph>preserve</codeph> or by
                    their presence in the <xref
                      href="#preferences-editor-format-xml/element-spacing-section" format="dita"
                        ><uicontrol>Preserve space</uicontrol> tab of the <uicontrol>Element
                        Spacing</uicontrol> list</xref>) are ignored by the <uicontrol>Format and
                      Indent</uicontrol> operation. When this option is selected and you edit one of
                    these elements, its content is formatted.</dd>
                </dlentry>
                <dlentry id="dlentry_ifp_bgk_54b">
                  <dt><uicontrol>Indent on paste - sections with number of lines less than
                      300</uicontrol></dt>
                  <dd>When you paste a chunk of text that has fewer than 300 lines, the inserted
                    content is indented. To keep the original indent style of the document you copy
                    content from, deselect this option.</dd>
                </dlentry>
              </dl>
            </p>
          </dd>
        </dlentry>
      </dl></p>
  </body>
</topic>
